module Day7 (
  day7
) where

import Day7.Parser
import Day7.Interpreter
import Shared

day7 :: IO ()
day7 = do
   input <- readFile "ressources/day07-input"
   putStrLn "Day7"
   let parsed = forceRight $ parseTerminalLines input
   let tree = buildTree parsed
   let small = filterDirectories (<= 100000) tree
   let sumOfSmall = sumUp small
   putStrLn ("Sum of those directories is " ++ show sumOfSmall)
   let rootSize = snd . head $ sizeOfDirectories tree
   putStrLn ("Root size is " ++ show rootSize)
   let freeSpace = 70000000 - rootSize
   let requiredSpace = 30000000 - freeSpace
   putStrLn ("Required space is " ++ show requiredSpace)
   let bigEnough = filterDirectories (>= requiredSpace) tree
   let onlySizes = map snd bigEnough
   let smallest = minimum onlySizes
   putStrLn ("Smallest directory that is still large enough " ++ show smallest)

